package directory.service;

public class EmployeeDirectoryProxy implements directory.service.EmployeeDirectory {
  private boolean _useJNDI = true;
  private String _endpoint = null;
  private directory.service.EmployeeDirectory __employeeDirectory = null;
  
  public EmployeeDirectoryProxy() {
    _initEmployeeDirectoryProxy();
  }
  
  private void _initEmployeeDirectoryProxy() {
  
  if (_useJNDI) {
    try{
      javax.naming.InitialContext ctx = new javax.naming.InitialContext();
      __employeeDirectory = ((directory.service.EmployeeDirectoryService)ctx.lookup("java:comp/env/service/EmployeeDirectoryService")).getEmployeeDirectory();
      }
    catch (javax.naming.NamingException namingException) {}
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (__employeeDirectory == null) {
    try{
      __employeeDirectory = (new directory.service.EmployeeDirectoryServiceLocator()).getEmployeeDirectory();
      }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (__employeeDirectory != null) {
    if (_endpoint != null)
      ((javax.xml.rpc.Stub)__employeeDirectory)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    else
      _endpoint = (String)((javax.xml.rpc.Stub)__employeeDirectory)._getProperty("javax.xml.rpc.service.endpoint.address");
  }
  
}


public void useJNDI(boolean useJNDI) {
  _useJNDI = useJNDI;
  __employeeDirectory = null;
  
}

public String getEndpoint() {
  return _endpoint;
}

public void setEndpoint(String endpoint) {
  _endpoint = endpoint;
  if (__employeeDirectory != null)
    ((javax.xml.rpc.Stub)__employeeDirectory)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
  
}

public directory.service.EmployeeDirectory getEmployeeDirectory() {
  if (__employeeDirectory == null)
    _initEmployeeDirectoryProxy();
  return __employeeDirectory;
}

public void modifyEmployee(directory.service.FullEmployeeRecord employee) throws java.rmi.RemoteException{
  if (__employeeDirectory == null)
    _initEmployeeDirectoryProxy();
  __employeeDirectory.modifyEmployee(employee);
}

public void normalizeNextID() throws java.rmi.RemoteException{
  if (__employeeDirectory == null)
    _initEmployeeDirectoryProxy();
  __employeeDirectory.normalizeNextID();
}

public directory.service.FullEmployeeRecord createNewFullEmployeeRecord() throws java.rmi.RemoteException{
  if (__employeeDirectory == null)
    _initEmployeeDirectoryProxy();
  return __employeeDirectory.createNewFullEmployeeRecord();
}

public directory.service.FullEmployeeRecord getFullEmployeeRecord(java.lang.Integer employeeID) throws java.rmi.RemoteException{
  if (__employeeDirectory == null)
    _initEmployeeDirectoryProxy();
  return __employeeDirectory.getFullEmployeeRecord(employeeID);
}

public void removeEmployee(java.lang.Integer employeeID) throws java.rmi.RemoteException{
  if (__employeeDirectory == null)
    _initEmployeeDirectoryProxy();
  __employeeDirectory.removeEmployee(employeeID);
}

public directory.service.LightEmployeeRecord[] getLightEmployeeRecords() throws java.rmi.RemoteException{
  if (__employeeDirectory == null)
    _initEmployeeDirectoryProxy();
  return __employeeDirectory.getLightEmployeeRecords();
}


}