package jve.generated;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

/**
 * Provide access to a Web Service proxy as a data source.
 * This class relies on the structure of Web Service client proxies generated
 * by the IBM Web services WSDL2Java emitter.<p>
 * 
 * This data source is configured by specifiying the fully qualified class name
 * of the Locator class of the client proxy, and the get service method within the
 * Locator class.
 *
 */
public class WebServiceDataSource implements IDataSource {

	private String serviceLocatorName = null;

	private String serviceMethod = null;

	private Object service;

	/**
	 * @return Returns the serviceMethod.
	 */
	public String getServiceMethod() {
		return serviceMethod;
	}

	/**
	 * @param serviceMethod The serviceMethod to set.
	 */
	public void setServiceMethod(String serviceMethod) {
		// chop off the parens from the method name if they're passed in
		int index = serviceMethod.indexOf("(");
		if (index != -1) {
			serviceMethod = serviceMethod.substring(0, index);
		}
		this.serviceMethod = serviceMethod;
	}

	/**
	 * @return Returns the serviceLocatorName.
	 */
	public String getServiceLocatorName() {
		return serviceLocatorName;
	}

	/**
	 * @param locatorName The serviceLocatorName to set.
	 */
	public void setServiceLocatorName(String locatorName) {
		serviceLocatorName = locatorName;
	}

	public Class getType() {
		Class wsClass = null;

		if (getServiceLocatorName() != null && getServiceMethod() != null) {
			try {
				Class locatorClass = Class.forName(getServiceLocatorName());
				Method method = locatorClass.getDeclaredMethod(
						getServiceMethod(), new Class[0]);
				wsClass = method.getReturnType();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			} catch (SecurityException e) {
				e.printStackTrace();
			} catch (NoSuchMethodException e) {
				e.printStackTrace();
			}
		}
		return wsClass;
	}

	public Object getDataSource() {
		if (service == null) {
			// Return the class for the stub - but NOT at design-time!
			if (java.beans.Beans.isDesignTime()) {
				return null;
			}

			try {
				Class locatorClass = getClass().getClassLoader().loadClass(
						getServiceLocatorName());
				Method serviceMeth = locatorClass.getDeclaredMethod(
						getServiceMethod(), new Class[0]);

				// Get the null constructor for the locator.
				Constructor cons = locatorClass
						.getDeclaredConstructor(new Class[0]);
				if (cons != null && serviceMeth != null) {
					Object locator = cons.newInstance(new Object[0]);
					setDataSource(serviceMeth.invoke(locator, new Object[0]));
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return service;
	}

	public void setDataSource(Object service) {
		this.service = service;
	}
}